#
# äǥ쥯ȥ
#
# Copyright (c) Fuktommy <fuktommy@my.tramonline.net>
#
# Released under the GNU General Public License
#

package Hicky::Directory;
use Hicky::System;
use Hicky::Lookup;
use Hicky::Thread;

#-------------------------------------------------------------------------#
# 󥹥ȥ饯
# : ǥ쥯ȥ̾
sub new {
	my($this, $dirname) = @_;
	my @file = Hicky::System::find($dirname);
	my $lookup = new Hicky::Lookup();
	my($f, $t);
	local $_;
	my @done = ();
	my %thread = ();

	foreach $f (@file) {
		$f =~ s/\n//;
		my @input = Hicky::System::nkf($f);
		$_ = $input[0];
		if (/<base href=/) {
			$lookup->addSubback(@input);
			next;
		} elsif (/^<html><head><title>2ch bookmark/) {
			$lookup->addBookmarkStream(@input);
			next;
		} else {
			$t = new Hicky::Thread(@input);
		}
		next unless (defined $t);
		push @done, $f;
		if ($thread{$t->getTitle()}) {
			$thread{$t->getTitle()}->merge($t);
		} else {
			$thread{$t->getTitle()} = $t;
		}
	}

	$this = {thread=>\%thread, done=>\@done, lookup=>$lookup, dir=>$dirname};
	return bless $this;
}

#-------------------------------------------------------------------------#
# åɤμ
# : åɤΥȥ
# : åɥ֥
sub getThread {
	my($this, $title) = @_;
	return $$this{thread}{$title};
}

#-------------------------------------------------------------------------#
# 
# : ɲäǥ쥯ȥ
sub append {
	my($this, $guest) = @_;
	local $_;
	my($base, $t);

	my @thread = values %{$$guest{thread}};
	foreach $t (@thread) {
		my $title = $t->getTitle();
		if (! defined $$this{thread}{$title}) {
			$$this{thread}{$title} = $t;
		} elsif (! $$this{thread}{$title}{load}) {
			$$this{thread}{$title}->load();
			$$this{thread}{$title}->merge($t);
			push @{$$this{done}}, $$this{thread}{$title}{file};
		} else {
			$$this{thread}{$title}->merge($t);
		}
	}

#	foreach $base (@{$$guest{lookup}{base}}) {
#		foreach (keys %{$$this{url}}) {
#			if ($$this{lookup}{url}{$_} =~ /^$base/) {
#				undef $this{url}{$_};
#			}
#		}
#	}

	foreach (keys %{$$guest{lookup}{url}}) {
		$$this{lookup}{url}{$_} = $$guest{lookup}{url}{$_};
	}

	push @{$$this{done}}, @{$$guest{done}};
}

#-------------------------------------------------------------------------#
# 
sub print {
	my($this) = @_;
	my $f = 1;
	my($t, $j);
	my $dir = $$this{dir};
	my $index    = "$dir/$main::conf{name_index}";
	my $bookmark = "$dir/$main::conf{name_bookmark}";
	my %lookup   = %{$$this{lookup}{url}};

	my @threads = keys %{$$this{thread}};
	@threads = sort @threads;

	Hicky::System::bak($index) if (-e $index);
	Hicky::System::bak($bookmark) if (-e $bookmark);
	open INDEX,    ">$index"    or die "$0: $index: File cannot open.\n";
	open BOOKMARK, ">$bookmark" or die "$0: $bookmark: File cannot open.\n";
	$f &= print INDEX    "<html><head><title>2ch log</title></head><body>\n";
	$f &= print BOOKMARK "<html><head><title>2ch bookmark</title></head><body>\n";

	my $i = 1;
	foreach $t (@threads) {
		$_ = $$this{thread}{$t};
		if ($$_{load}) {
			while (-e ($output = sprintf("$dir/2chlog-%03d.html", $i))) {
				$i++;
			}
			$_->plastic();
			$j = $i;
		} elsif ($$_{file}) {
			$$_{file} =~ /-(\d+)/;
			$j = $1;
		} else {
			#warn "$t\n";
			#die;
			next;
		}
		$f &= printf INDEX
			"<a href='2chlog-%03d.html'>%03d: %s</a><br>\n", $j, $j, $_->getTitle();
		if ((defined $lookup{$_->getTitleNoSpace()}) &&
				($_->getMaxRes() < $main::conf{limit}) &&
 				($_->getMaxRes() > 1)) {
			$f &= printf BOOKMARK "<a href='%s/%d-n'>%s</a><br>\n",
					$lookup{$_->getTitleNoSpace()},
					$_->getMaxRes()+1,
					$_->getTitle();
		}
		if ($$_{load}) {
			open OUT, ">$output" or die "$0: $output: File cannot open.\n";
			select OUT;
			$f &= $_->print();
			close OUT;
		}
	}

	print INDEX    "</body></html>\n";
	print BOOKMARK "</body></html>\n";
	close INDEX;
	close BOOKMARK;

	# Ȥäեκ
	if ($f != 0) {
		Hicky::System::del($_) foreach (@{$$this{done}});
	} else {
		die "$0: Source HTMLs are not deleated.\n";
	}
}

1;
